unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type

  CaptureDevice = record
    provider_id: string;
    tuning_mode: string;
    tuning_plugin: string;
    encoder_merit: string;
    device_name: string;
    device_num: string;
  end;

  Zap2ItData = record
    StnNum: string;
    Channel: string;
    StnName: string;
  end;

  SiliconDustData = record
    Modulation: string;
    h_Freq: string;
    h_PhyProg: string;
    GuideNo: string;
    GuideName: string;
    Resolution: string;
    Aspect: string;
  end;

  SageScanData = record
    PhyMajMin: string;
    s_PhyProg: string;
    s_Freq: string;
  end;

  TForm1 = class(TForm)
    ShowZap2It: TButton;
    Memo1: TMemo;
    ShowHDHR: TButton;
    ShowRemap: TButton;
    Zap2ItEdit: TEdit;
    Button1: TButton;
    Label1: TLabel;
    SiliconDustEdit: TEdit;
    Button2: TButton;
    Label2: TLabel;
    SageScanEdit: TEdit;
    Button3: TButton;
    Label3: TLabel;
    OpenDialog1: TOpenDialog;
    Label4: TLabel;
    DeviceUpDown: TUpDown;
    DeviceName: TStaticText;
    Label6: TLabel;
    TuningMode: TStaticText;
    TmLable: TLabel;
    TuningPlugin: TStaticText;
    Label7: TLabel;
    EncoderMerit: TStaticText;
    Label8: TLabel;
    Label9: TLabel;
    SagePropertiesEdit: TEdit;
    Button4: TButton;
    ProviderId: TStaticText;
    ProviderIds: TComboBox;
    Label5: TLabel;
    DataSources: TComboBox;
    Label10: TLabel;
    Label11: TLabel;
    Ds_ServiceLevel: TStaticText;
    Label12: TLabel;
    Ds_EpgName: TStaticText;
    Label13: TLabel;
    Ds_ProviderId: TStaticText;
    ShowLineup: TButton;
    SortComboBox: TComboBox;
    Label14: TLabel;
    procedure ShowZap2ItClick(Sender: TObject);
    procedure ShowHDHRClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ShowRemapClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DeviceUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure DataSourcesChange(Sender: TObject);
    procedure ShowLineupClick(Sender: TObject);
    procedure SortComboBoxChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  s,z_File,h_File,s_File: string;
  StnData: array[0..6,0..1000] of string;
  Lineups,Overrides,PhyOverrides,ServiceLevels,ServiceLevel,
  UnavailStations,PropStr,EpgName,EpsProviderId: array[0..10] of string;
  CapDevice: array[1..20] of CaptureDevice;
  Zap2It: array of Zap2ItData;
  HdHr: array of SiliconDustData;
  SageScan: array of SageScanData;
  Zap2ItCount,HdHrCount,SageScanCount,DevCount,PropStrCount,SortIndex: integer;
 	z_FileExists,h_FileExists,s_FileExists,p_FileExists: boolean;
  TxtFile: TextFile;
  StationList: TStringList;

implementation

{$R *.DFM}


function GetEnclosedString(s1,s2: string): string;
var
  i,j: integer;
begin
  i:=pos(s1,s)+length(s1);
  j:=pos(s2,s);
  result:=copy(s,i,j-i);
end;

function GetZap2ItData(f: string): boolean;
var
  i,j,n: integer;
begin
  with Form1 do
  begin
    result:=false;
    if FileExists(f) then
    begin
     	try
        SetLength(Zap2It,1000);
  			AssignFile(TxtFile,f);
  			Reset(TxtFile);
  			Zap2ItCount:=0;
        with Zap2It[0] do
        begin
        	StnNum:='   -';
          Channel:='   -';
          StnName:='   -';
        end;
        while not eof(TxtFile) do
        begin
          Readln(TxtFile,s);
          i:=pos('stnNum=',s);
          if i>0 then
          begin
            inc(Zap2ItCount);
            Zap2It[Zap2ItCount]:=Zap2It[0];
            with Zap2It[Zap2ItCount] do
            begin
              s:=copy(s,i+7,255);
              i:=pos('&',s);
              StnNum:=copy(s,1,i-1);
              j:=pos('"',s);
              Channel:=copy(s,i+9,j-i-9);
              for n:=1 to 4 do
              begin
                Readln(TxtFile,s);
                i:=pos('zc-st-c',s);
                if i>0 then
                begin
                  j:=pos('</',s);
                  StnName:=copy(s,i+9,j-i-9);
                  break;
                end;
              end;
            end;
          end;
        end;
        result:=true;
     	finally
  			CloseFile(TxtFile);
        SetLength(Zap2It,Zap2ItCount+1);
      end;
    end;
  end;
end;

function GetHdHRData(f: string): boolean;
var
  code,StrValue,PhysicalChannel: string;
  i,j: integer;
begin
  with Form1 do
  begin
    result:=false;
    if FileExists(f) then
    begin
     	try
        SetLength(HdHr,1000);
  			AssignFile(TxtFile,f);
  			Reset(TxtFile);
  			HdHrCount:=0;
        with HdHr[0] do
        begin
        	Modulation:='   -';
          h_Freq:='   -';
          h_PhyProg:='   -';
          GuideNo:='   -';
          GuideName:='   -';
          Resolution:='   -';
          Aspect:='   -';
        end;
        while not eof(TxtFile) do
        begin
          Readln(TxtFile,s);
          code:=GetEnclosedString('<','>');
          if code='Program' then
          begin
            inc(HdHrCount);
            HdHr[HdHrCount]:=HdHr[0];
            with HdHr[HdHrCount] do
            for i:=1 to 8 do
            begin
          		Readln(TxtFile,s);
            	code:=GetEnclosedString('<','>');
              if code='/Program' then break;
              StrValue:=GetEnclosedString('>','</');
              j:=pos(code,'Modulation>Frequency>PhysicalChannel>ProgramNumber>GuideNumber>GuideName>Resolution>Aspect');
              case j of
              1:  Modulation:=StrValue;
              12: h_Freq:=StrValue;
              22: PhysicalChannel:=StrValue;
              38: h_PhyProg:=PhysicalChannel+'-'+StrValue;
              52: GuideNo:=StrValue;
              64: GuideName:=StrValue;
              74: Resolution:=StrValue;
              85: Aspect:=StrValue;
              end;
            end;
          end;
        end;
        result:=true;
     	finally
  			CloseFile(TxtFile);
        SetLength(HdHr,HdHrCount+1);
      end;
    end;
  end;
end;

function GetSageScanData(f: string): boolean;
begin
  with Form1 do
  begin
    result:=false;
    if FileExists(f) then
    begin
     	try
        SetLength(SageScan,1000);
  			AssignFile(TxtFile,f);
  			Reset(TxtFile);
  			SageScanCount:=0;
        with SageScan[0] do
        begin
        	PhyMajMin:='   -';
          s_PhyProg:='   -';
          s_Freq:='   -';
        end;
        while not eof(TxtFile) do
        begin
          Readln(TxtFile,s);
          if copy(s,1,3)='CH:' then
          begin
            inc(SageScanCount);
            SageScan[SageScanCount]:=SageScan[0];
            with SageScan[SageScanCount] do
            begin
              PhyMajMin:=GetEnclosedString('phy:',' frq')+'-'+GetEnclosedString('major:',' minor')+'-'+GetEnclosedString('minor:',' prog');
              s_PhyProg:=GetEnclosedString('phy:',' frq')+'-'+GetEnclosedString('prog:',' phy');
              s_Freq:=GetEnclosedString('frq:',' mod');
            end;
          end;
        end;
        result:=true;
     	finally
  			CloseFile(TxtFile);
        SetLength(SageScan,SageScanCount+1);
      end;
    end;
  end;
end;

function GetPropertyStrings: string;
var
  i,l: integer;
begin
  PropStrCount:=-1;
  l:=length(s);
  i:=pos('/',s);
  while i>0 do
  begin
    inc(PropStrCount);
    PropStr[PropStrCount]:=copy(s,1,i);  //include the "/"
    s:=copy(s,i+1,l);
    i:=pos('/',s);
  end;
  i:=pos('=',s);
  inc(PropStrCount);
  PropStr[PropStrCount]:=copy(s,1,i-1);    //don't include the "="
  result:=copy(s,i+1,l);  //return all that follows the "="
end;

function GetSageProperties(f: string): boolean;
var
  i,j,Dev1,n: integer;
  CurrentEncoder: string;
  DeviceUsed: boolean;
begin
  with Form1 do
  begin
    result:=false;
    if FileExists(f) then
    begin
     	try
        DevCount:=0;
        for n:=0 to 10 do
        begin
          Lineups[n]:='';
          Overrides[n]:='';
          PhyOverrides[n]:='';
          ServiceLevels[n]:='';
          ServiceLevel[n]:='';
          UnavailStations[n]:='';
          PropStr[n]:='';
          EpgName[n]:='';
          EpsProviderId[n]:='';
        end;
        ProviderIds.Clear;
        DataSources.Clear;
        AssignFile(TxtFile,f);
        Reset(TxtFile);
        while not eof(TxtFile) do
        begin
          Readln(TxtFile,s);
          if s[1]<>'#' then
          begin
            s:=GetPropertyStrings;
            i:=pos(PropStr[0],'ChannelSxxx/epg/epg_data_sources/mmc/'); //add ChannelScan later
            case i of
            13: begin
                  j:=pos(PropStr[1],'channel_lineups/lineup_overrides/lineup_physical_overrides/service_levels/');
                  case j of
                  1:  begin
                        n:=ProviderIds.Items.IndexOf(PropStr[2]);
                        if n<0 then n:=ProviderIds.Items.Add(PropStr[2]);
                        Lineups[n]:=s;
                      end;
                  17: begin
                        n:=ProviderIds.Items.IndexOf(PropStr[2]);
                        if n<0 then n:=ProviderIds.Items.Add(PropStr[2]);
                        Overrides[n]:=s;
                      end;
                  34: begin
                        n:=ProviderIds.Items.IndexOf(PropStr[2]);
                        if n<0 then n:=ProviderIds.Items.Add(PropStr[2]);
                        PhyOverrides[n]:=s;
                      end;
                  60: begin
                        n:=ProviderIds.Items.IndexOf(PropStr[2]);
                        if n<0 then n:=ProviderIds.Items.Add(PropStr[2]);
                        ServiceLevels[n]:=s;
                      end;
                  end;
                end;
            17: begin
                  j:=pos(PropStr[2],'applied_service_level/epg_name/provider_id/unavailable_stations');
                  case j of
                  1:  begin
                        n:=DataSources.Items.IndexOf(PropStr[1]);
                        if n<0 then n:=DataSources.Items.Add(PropStr[1]);
                        ServiceLevel[n]:=s;
                      end;
                  23: begin
                        n:=DataSources.Items.IndexOf(PropStr[1]);
                        if n<0 then n:=DataSources.Items.Add(PropStr[1]);
                        EpgName[n]:=s;
                      end;
                  32: begin
                        n:=DataSources.Items.IndexOf(PropStr[1]);
                        if n<0 then n:=DataSources.Items.Add(PropStr[1]);
                        EpsProviderId[n]:=s;
                      end;
                  44: begin
                        n:=DataSources.Items.IndexOf(PropStr[1]);
                        if n<0 then n:=DataSources.Items.Add(PropStr[1]);
                        UnavailStations[n]:=s;
                      end;
                  end;
                end;
            34: if PropStr[1]='encoders/' then
                begin
                  if PropStr[2]<>CurrentEncoder then
                  begin
                    Dev1:=DevCount+1;
                    CurrentEncoder:=PropStr[2];
                  end;
                  if PropStrCount=5 then
                  begin
                    j:=pos(PropStr[5],'provider_id/tuning_mode/tuning_plugin');
                    case j of
                    1:  begin
                          DeviceUsed:=s<>'0';
                          if DeviceUsed then
                          begin
                            Inc(DevCount);
                            CapDevice[DevCount].provider_id:=s;
                          end;
                        end;
                    13: if DeviceUsed then CapDevice[DevCount].tuning_mode:=s;
                    25: if DeviceUsed then CapDevice[DevCount].tuning_plugin:=s;
                    end;
                  end
                  else
                  begin
                    j:=pos(PropStr[3],'encoder_merit/video_capture_device_name/video_capture_device_num');
                    case j of
                    1:  for n:=Dev1 to DevCount do CapDevice[n].encoder_merit:=s;
                    15: for n:=Dev1 to DevCount do CapDevice[n].device_name:=s;
                    41: for n:=Dev1 to DevCount do CapDevice[n].device_num:=s;
                    end;
                  end;
                end;
            end;
          end;
        end;
        result:=true;
        for n:=0 to DataSources.Items.Count-1 do
          DataSources.Items[n]:=copy(DataSources.Items[n],1,length(DataSources.Items[n])-1);
        DataSources.ItemIndex:=0;
        DataSourcesChange(DataSources);
        DeviceUpDown.Max:=DevCount;
        DeviceUpDownClick(DeviceUpDown,btNext);
        ProviderIds.ItemIndex:=0;
     	finally
  			CloseFile(TxtFile);
        SetLength(SageScan,SageScanCount+1);
      end;
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  sr: TSearchRec;
begin
	ForceCurrentDirectory:=true;
  SortComboBox.ItemIndex:=0;
  SortIndex:=0;
  z_FileExists:=GetZap2ItData('Zap2It.txt');
  if z_FileExists then Zap2ItEdit.Text:='Zap2It.txt';
  h_FileExists:=GetHdHRData('SiliconDust.txt');
  if h_FileExists then SiliconDustEdit.Text:='SiliconDust.txt';
  if FindFirst('*.frq',faAnyFile,sr) = 0 then
  begin
  	s_FileExists:=GetSageScanData(sr.Name);
    if s_FileExists then SageScanEdit.Text:=sr.Name;
    FindClose(sr);
  end;
  p_FileExists:=GetSageProperties('Sage.properties');
  if p_FileExists then SagePropertiesEdit.Text:='Sage.properties';
  StationList:=TStringList.Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Zap2It:=nil;
  HdHr:=nil;
  SageScan:=nil;
  StationList.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  t: integer;
begin
  t:=TControl(Sender).Tag;
  with OpenDialog1 do
  begin
    if t=2 then Filter:='Sage scan file (*.frq)|*.FRQ'
    else if t=3 then Filter:='Sage properties file (*.properties)|*.PROPERTIES'
    else  Filter:='Text files (*.txt)|*.TXT';
    if Execute then
      case t of
      0:	begin
            z_FileExists:=GetZap2ItData(FileName);
            if z_FileExists then Zap2ItEdit.Text:=FileName;
      		end;
      1:	begin
            h_FileExists:=GetHdHRData(FileName);
            if h_FileExists then SiliconDustEdit.Text:=FileName;
      		end;
      2:	begin
            s_FileExists:=GetSageScanData(FileName);
            if s_FileExists then SageScanEdit.Text:=FileName;
      		end;
      3:	begin
            p_FileExists:=GetSageProperties(FileName);
            if p_FileExists then SagePropertiesEdit.Text:=FileName;
      		end;
      end;
  end;
end;

procedure TForm1.ShowZap2ItClick(Sender: TObject);
var
  n: integer;
begin
  if not z_FileExists then
  begin
    ShowMessage('You must first identify a valid Zap2It text file.');
    exit;
  end;
  Memo1.Clear;
  Memo1.Lines.Add('Sta Name Channel StnNum');
  Memo1.Lines.Add('-------- ------- ------');
  for n:=1 to Zap2ItCount do with Zap2It[n] do
   	Memo1.Lines.Add(Format('%-8s%8s%7s',[StnName,Channel,StnNum]));
end;

procedure TForm1.ShowHDHRClick(Sender: TObject);
var
  i,j,n: integer;
  IsAQam: boolean;
begin
  if not h_FileExists then
  begin
    ShowMessage('You must first identify the SiliconDust text file.');
    exit;
  end;
  Memo1.Clear;
  Memo1.Lines.Add('  Mod   Phy-Prog  Frequency Number   Name   Resolution Aspect Channel StnNum');
  Memo1.Lines.Add('------ ---------- --------- ------ -------- ---------- ------ ------- ------');
  for n:=1 to HdHrCount do with HdHr[n] do
    if z_FileExists then
    begin
      i:=0;
      for j:=1 to Zap2ItCount do
        if GuideName=Zap2It[j].StnName then
        begin
          i:=j;
          break;
        end;
    	Memo1.Lines.Add(Format('%6s %-10s%10s%7s%9s%11s%7s%8s%7s',[Modulation,h_PhyProg,h_Freq,GuideNo,GuideName,Resolution,Aspect,Zap2It[i].Channel,Zap2It[i].StnNum]));
    end
    else
    	Memo1.Lines.Add(Format('%6s %-10s%10s%7s%9s%11s%7s   -       -',[Modulation,h_PhyProg,h_Freq,GuideNo,GuideName,Resolution,Aspect]));
end;

procedure TForm1.ShowRemapClick(Sender: TObject);
var
  i,j,k,m,n: integer;
  code,PhysicalChannel,ProgramNumber,s_Major,s_Minor,s_Prog,s_Phy: string;
  IsAQam: boolean;
begin
  if not (z_FileExists and h_FileExists and s_FileExists) then
  begin
    ShowMessage('You must first identify the first three files.');
    exit;
  end;
//1st, test for misnamed channel -- lacking 'DT' at end
  for i:=1 to HdHrCount do with HdHr[i] do
    if (Aspect='16:9') and (copy(GuideName,length(GuideName)-2,2)<>'DT') then
    begin
      s:=GuideName+'DT';
      for j:=1 to HdHrCount do
        if s=HdHr[j].GuideName then break;
      for j:=1 to Zap2ItCount do
        if s=Zap2It[j].StnName then
        begin
          GuideName:=s;
          break;
        end;
    end;
  Memo1.Clear;
  Memo1.Lines.Add('            Remap to:             Sage Scan   HD-HR');
  Memo1.Lines.Add(' Channel   Number   Name   StnNum Frequency Frequency');
  Memo1.Lines.Add('---------- ------ -------- ------ --------- ---------');
  for i:=1 to SageScanCount do with SageScan[i] do
  begin
    m:=0;
    for j:=1 to HdHrCount do with HdHr[j] do
      if h_PhyProg=s_PhyProg then
      begin
        n:=0;
        for k:=1 to Zap2ItCount do with Zap2It[k] do
          if StnName=GuideName then
          begin
            n:=k;
            break;
          end;
        m:=j;
        break;
      end;
    Memo1.Lines.Add(Format('%-10s%7s%9s%7s%10s%10s',
      [PhyMajMin,Zap2It[n].Channel,HdHr[m].GuideName,Zap2It[n].StnNum,s_Freq,HdHr[m].h_Freq]));
  end;
end;

procedure TForm1.DeviceUpDownClick(Sender: TObject; Button: TUDBtnType);
begin
  with CapDevice[DeviceUpDown.Position] do
  begin
    DeviceName.Caption:=device_name+' #'+device_num;
    ProviderId.Caption:=provider_id;
    TuningMode.Caption:=tuning_mode;
    TuningPlugin.Caption:=tuning_plugin;
    EncoderMerit.Caption:=encoder_merit;
  end;
end;

procedure TForm1.DataSourcesChange(Sender: TObject);
var
  n: integer;
begin
  n:=DataSources.ItemIndex;
  Ds_ServiceLevel.Caption:=ServiceLevel[n];
  Ds_EpgName.Caption:=EpgName[n];
  Ds_ProviderId.Caption:=EpsProviderId[n];
end;

procedure AddStnData(s: string; p: integer);
var
  i,j,k,l,n: integer;
  a: string;
begin
  l:=length(s);
  for n:=0 to 1000 do
  begin
    i:=pos(',',s);
    if i<1 then exit;
    j:=pos(';',s);
    a:=copy(s,1,i-1);
    k:=StationList.IndexOf(a);
    if k<0 then k:=StationList.Add(a);
    StnData[p,k]:=copy(s,i+1,j-i-1);
    s:=copy(s,j+1,l);
  end;
end;

function GetNumeric(a: string): integer;
var
  i: integer;
begin
  i:=pos('-',a);
  if i>0 then result:=StrToInt(copy(a,1,i-1)) else result:=2147483647;
end;

function GetOneChannel(a: string): integer;
var
  i,j,k: integer;
begin
  if a='' then result:=2147483647
  else
  begin
    i:=pos('&',a);
    if i>0 then
    begin
      j:=StrToInt(copy(a,1,i-1));
      k:=StrToInt(copy(a,i+1,256));
      if j<k then result:=j else result:=k;
    end
    else result:=StrToInt(a);
  end;
end;

procedure TForm1.ShowLineupClick(Sender: TObject);
var
  i,j,k,l,n,p,s_count: integer;
  Seq: array[0..1000] of integer;
  Sorted: array[0..1000] of boolean;
begin
  for n:=0 to 1000 do
    for i:=1 to 6 do StnData[i,n]:='';
  n:=ProviderIds.ItemIndex;
  StationList.Clear;
  if Lineups[n]<>'' then AddStnData(Lineups[n],1);
  if Overrides[n]<>'' then AddStnData(Overrides[n],2);
  if PhyOverrides[n]<>'' then AddStnData(PhyOverrides[n],3);
  s:='';
  for i:=0 to DataSources.Items.Count-1 do
    if EpsProviderId[i]=ProviderIds.Items[n] then
    begin
      s:=UnavailStations[i];
      l:=length(s);
      break;
    end;
  if s<>'' then for i:=0 to 1000 do
  begin
    j:=pos(',',s);
    if j<1 then break;
    k:=StationList.IndexOf(copy(s,1,j-1));
    if k>-1 then StnData[4,k]:='no';
    s:=copy(s,j+1,l);
  end;
  Memo1.Clear;
  Memo1.Lines.Add('  StnNum  Lineup  Override Phy-Override Avail Sta Name Channel');
  Memo1.Lines.Add('--------- ------- -------- ------------ ----- -------- -------');
  s_count:=StationList.Count-1;
  for n:=0 to s_count do
  begin
    Sorted[n]:=false;
    s:=StationList[n];
    StnData[0,n]:=s;
    for i:=1 to Zap2ItCount do with Zap2It[i] do
      if StnNum=s then
      begin
        StnData[5,n]:=StnName;
        StnData[6,n]:=Channel;
        break;
      end;
  end;
  for n:=0 to s_count do
  begin
    i:=0;
    while Sorted[i] do inc(i);
    k:=i;
    for j:=i+1 to s_count do
      if (not Sorted[j]) then
        case SortIndex of
        0,1,6:  if GetOneChannel(StnData[SortIndex,j])<GetOneChannel(StnData[SortIndex,k]) then k:=j;
        2,3:    if GetNumeric(StnData[SortIndex,j])<GetNumeric(StnData[SortIndex,k]) then k:=j;
        4,5:    if StnData[SortIndex,j]<StnData[SortIndex,k] then k:=j;
        end;
    Seq[n]:=k;
    Sorted[k]:=true;
  end;
  for i:=0 to s_count do
  begin
    n:=Seq[i];
    Memo1.Lines.Add(Format('%9s%8s%9s%13s   %2s  %-8s%8s',[StnData[0,n],StnData[1,n],StnData[2,n],StnData[3,n],StnData[4,n],StnData[5,n],StnData[6,n]]));
  end;
end;


procedure TForm1.SortComboBoxChange(Sender: TObject);
begin
  SortIndex:=SortComboBox.ItemIndex;
end;

end.
{
ChannelScan/
epg/channel_lineups/
epg/lineup_overrides/
epg/lineup_physical_overrides/
epg/service_levels/
epg_data_sources/
applied_service_level
epg_name
provider_id
unavailable_stations
mmc/encoders/
provider_id
tuning_mode
tuning_plugin
encoder_merit
video_capture_device_name
video_capture_device_num
}

//                                                1234567890  1234567890
//<a class="zc-st-a" href="/tvlistings/ZCSGrid.do?stnNum=17098&channel=4">
//             1234567890
//<span class="zc-st-c">WGNAMER</span>

//                                                1234567890  1234567890
//                        1         2         3         4         5         6         7         8         9
//               1234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890
//CH:1 major:10 minor:1 prog:1 phy:71 frq:505250000 mod:11 inv:0 #:KSAZ-HD 		[KSAZDT 	710
//CH:27 major:0 minor:1 prog:1 phy:103 frq:667250000 mod:11 inv:0 #:DTV103.1		[KUTP		9

{
 AssignFile(TxtFile,'Sage.properties');
  Reset(TxtFile);
  while not eof(TxtFile) do
  begin
    Readln(TxtFile,s);
//          123456789012345678901234567890
    i:=pos('video_capture_device_name',s);
    if i>0 then
      CaptureDevice.Items.Add(Copy(s,i+26,256));
  end;
      12345678901234
			<Modulation>qam64</Modulation>
			<Frequency>93000000</Frequency>
			<PhysicalChannel>95</PhysicalChannel>
			<ProgramNumber>1</ProgramNumber>
			<GuideNumber></GuideNumber>
			<GuideName>LEAC022</GuideName>
			<Resolution>544x480i</Resolution>
			<Aspect>4:3</Aspect>
			<Snapshot>13141343</Snapshot>
			<Snapshot>13120352</Snapshot>
			<Snapshot>12879206</Snapshot>
}

